/*
 * generated by Xtext 2.12.0
 */
package fr.n7.petrinet.txt.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.EnumLiteralDeclaration;
import org.eclipse.xtext.EnumRule;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractEnumRuleElementFinder;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class NETGrammarAccess extends AbstractGrammarElementFinder {
	
	public class ReseauElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.Reseau");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cReseauKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cNomKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cNomAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cNomEStringParserRuleCall_3_0 = (RuleCall)cNomAssignment_3.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cArcKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_4_1 = (Keyword)cGroup_4.eContents().get(1);
		private final Assignment cArcAssignment_4_2 = (Assignment)cGroup_4.eContents().get(2);
		private final RuleCall cArcArcParserRuleCall_4_2_0 = (RuleCall)cArcAssignment_4_2.eContents().get(0);
		private final Group cGroup_4_3 = (Group)cGroup_4.eContents().get(3);
		private final Keyword cCommaKeyword_4_3_0 = (Keyword)cGroup_4_3.eContents().get(0);
		private final Assignment cArcAssignment_4_3_1 = (Assignment)cGroup_4_3.eContents().get(1);
		private final RuleCall cArcArcParserRuleCall_4_3_1_0 = (RuleCall)cArcAssignment_4_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_4_4 = (Keyword)cGroup_4.eContents().get(4);
		private final Keyword cElementpetriKeyword_5 = (Keyword)cGroup.eContents().get(5);
		private final Keyword cLeftCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Assignment cElementpetriAssignment_7 = (Assignment)cGroup.eContents().get(7);
		private final RuleCall cElementpetriElementPetriParserRuleCall_7_0 = (RuleCall)cElementpetriAssignment_7.eContents().get(0);
		private final Group cGroup_8 = (Group)cGroup.eContents().get(8);
		private final Keyword cCommaKeyword_8_0 = (Keyword)cGroup_8.eContents().get(0);
		private final Assignment cElementpetriAssignment_8_1 = (Assignment)cGroup_8.eContents().get(1);
		private final RuleCall cElementpetriElementPetriParserRuleCall_8_1_0 = (RuleCall)cElementpetriAssignment_8_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_9 = (Keyword)cGroup.eContents().get(9);
		private final Keyword cRightCurlyBracketKeyword_10 = (Keyword)cGroup.eContents().get(10);
		
		//Reseau:
		//	'Reseau'
		//	'{'
		//	'nom' nom=EString ('arc' '{' arc+=Arc ("," arc+=Arc)* '}')?
		//	'elementpetri' '{' elementpetri+=ElementPetri ("," elementpetri+=ElementPetri)* '}'
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'Reseau' '{' 'nom' nom=EString ('arc' '{' arc+=Arc ("," arc+=Arc)* '}')? 'elementpetri' '{' elementpetri+=ElementPetri
		//("," elementpetri+=ElementPetri)* '}' '}'
		public Group getGroup() { return cGroup; }
		
		//'Reseau'
		public Keyword getReseauKeyword_0() { return cReseauKeyword_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1() { return cLeftCurlyBracketKeyword_1; }
		
		//'nom'
		public Keyword getNomKeyword_2() { return cNomKeyword_2; }
		
		//nom=EString
		public Assignment getNomAssignment_3() { return cNomAssignment_3; }
		
		//EString
		public RuleCall getNomEStringParserRuleCall_3_0() { return cNomEStringParserRuleCall_3_0; }
		
		//('arc' '{' arc+=Arc ("," arc+=Arc)* '}')?
		public Group getGroup_4() { return cGroup_4; }
		
		//'arc'
		public Keyword getArcKeyword_4_0() { return cArcKeyword_4_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_4_1() { return cLeftCurlyBracketKeyword_4_1; }
		
		//arc+=Arc
		public Assignment getArcAssignment_4_2() { return cArcAssignment_4_2; }
		
		//Arc
		public RuleCall getArcArcParserRuleCall_4_2_0() { return cArcArcParserRuleCall_4_2_0; }
		
		//("," arc+=Arc)*
		public Group getGroup_4_3() { return cGroup_4_3; }
		
		//","
		public Keyword getCommaKeyword_4_3_0() { return cCommaKeyword_4_3_0; }
		
		//arc+=Arc
		public Assignment getArcAssignment_4_3_1() { return cArcAssignment_4_3_1; }
		
		//Arc
		public RuleCall getArcArcParserRuleCall_4_3_1_0() { return cArcArcParserRuleCall_4_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4_4() { return cRightCurlyBracketKeyword_4_4; }
		
		//'elementpetri'
		public Keyword getElementpetriKeyword_5() { return cElementpetriKeyword_5; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_6() { return cLeftCurlyBracketKeyword_6; }
		
		//elementpetri+=ElementPetri
		public Assignment getElementpetriAssignment_7() { return cElementpetriAssignment_7; }
		
		//ElementPetri
		public RuleCall getElementpetriElementPetriParserRuleCall_7_0() { return cElementpetriElementPetriParserRuleCall_7_0; }
		
		//("," elementpetri+=ElementPetri)*
		public Group getGroup_8() { return cGroup_8; }
		
		//","
		public Keyword getCommaKeyword_8_0() { return cCommaKeyword_8_0; }
		
		//elementpetri+=ElementPetri
		public Assignment getElementpetriAssignment_8_1() { return cElementpetriAssignment_8_1; }
		
		//ElementPetri
		public RuleCall getElementpetriElementPetriParserRuleCall_8_1_0() { return cElementpetriElementPetriParserRuleCall_8_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_9() { return cRightCurlyBracketKeyword_9; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_10() { return cRightCurlyBracketKeyword_10; }
	}
	public class ArcElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.Arc");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cArcPTParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cArcTPParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Arc:
		//	ArcPT | ArcTP;
		@Override public ParserRule getRule() { return rule; }
		
		//ArcPT | ArcTP
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//ArcPT
		public RuleCall getArcPTParserRuleCall_0() { return cArcPTParserRuleCall_0; }
		
		//ArcTP
		public RuleCall getArcTPParserRuleCall_1() { return cArcTPParserRuleCall_1; }
	}
	public class ElementPetriElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.ElementPetri");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cTransitionParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cPlaceParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//ElementPetri:
		//	Transition | Place;
		@Override public ParserRule getRule() { return rule; }
		
		//Transition | Place
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//Transition
		public RuleCall getTransitionParserRuleCall_0() { return cTransitionParserRuleCall_0; }
		
		//Place
		public RuleCall getPlaceParserRuleCall_1() { return cPlaceParserRuleCall_1; }
	}
	public class EStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.EString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cSTRINGTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//EString:
		//	STRING | ID;
		@Override public ParserRule getRule() { return rule; }
		
		//STRING | ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_0() { return cSTRINGTerminalRuleCall_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1() { return cIDTerminalRuleCall_1; }
	}
	public class EIntElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.EInt");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		
		//EInt ecore::EInt:
		//	'-'? INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'-'? INT
		public Group getGroup() { return cGroup; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_0() { return cHyphenMinusKeyword_0; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_1() { return cINTTerminalRuleCall_1; }
	}
	public class ArcPTElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.ArcPT");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cArcPTKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cPoidsKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cPoidsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cPoidsEIntParserRuleCall_3_0 = (RuleCall)cPoidsAssignment_3.eContents().get(0);
		private final Keyword cTypeKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cTypeAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cTypeArcKindEnumRuleCall_5_0 = (RuleCall)cTypeAssignment_5.eContents().get(0);
		private final Keyword cTransitionKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Assignment cTransitionAssignment_7 = (Assignment)cGroup.eContents().get(7);
		private final CrossReference cTransitionTransitionCrossReference_7_0 = (CrossReference)cTransitionAssignment_7.eContents().get(0);
		private final RuleCall cTransitionTransitionEStringParserRuleCall_7_0_1 = (RuleCall)cTransitionTransitionCrossReference_7_0.eContents().get(1);
		private final Keyword cPlaceKeyword_8 = (Keyword)cGroup.eContents().get(8);
		private final Assignment cPlaceAssignment_9 = (Assignment)cGroup.eContents().get(9);
		private final CrossReference cPlacePlaceCrossReference_9_0 = (CrossReference)cPlaceAssignment_9.eContents().get(0);
		private final RuleCall cPlacePlaceEStringParserRuleCall_9_0_1 = (RuleCall)cPlacePlaceCrossReference_9_0.eContents().get(1);
		private final Keyword cRightCurlyBracketKeyword_10 = (Keyword)cGroup.eContents().get(10);
		
		//ArcPT:
		//	'ArcPT'
		//	'{'
		//	'poids' poids=EInt
		//	'type' type=ArcKind
		//	'transition' transition=[Transition|EString]
		//	'place' place=[Place|EString]
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'ArcPT' '{' 'poids' poids=EInt 'type' type=ArcKind 'transition' transition=[Transition|EString] 'place'
		//place=[Place|EString] '}'
		public Group getGroup() { return cGroup; }
		
		//'ArcPT'
		public Keyword getArcPTKeyword_0() { return cArcPTKeyword_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1() { return cLeftCurlyBracketKeyword_1; }
		
		//'poids'
		public Keyword getPoidsKeyword_2() { return cPoidsKeyword_2; }
		
		//poids=EInt
		public Assignment getPoidsAssignment_3() { return cPoidsAssignment_3; }
		
		//EInt
		public RuleCall getPoidsEIntParserRuleCall_3_0() { return cPoidsEIntParserRuleCall_3_0; }
		
		//'type'
		public Keyword getTypeKeyword_4() { return cTypeKeyword_4; }
		
		//type=ArcKind
		public Assignment getTypeAssignment_5() { return cTypeAssignment_5; }
		
		//ArcKind
		public RuleCall getTypeArcKindEnumRuleCall_5_0() { return cTypeArcKindEnumRuleCall_5_0; }
		
		//'transition'
		public Keyword getTransitionKeyword_6() { return cTransitionKeyword_6; }
		
		//transition=[Transition|EString]
		public Assignment getTransitionAssignment_7() { return cTransitionAssignment_7; }
		
		//[Transition|EString]
		public CrossReference getTransitionTransitionCrossReference_7_0() { return cTransitionTransitionCrossReference_7_0; }
		
		//EString
		public RuleCall getTransitionTransitionEStringParserRuleCall_7_0_1() { return cTransitionTransitionEStringParserRuleCall_7_0_1; }
		
		//'place'
		public Keyword getPlaceKeyword_8() { return cPlaceKeyword_8; }
		
		//place=[Place|EString]
		public Assignment getPlaceAssignment_9() { return cPlaceAssignment_9; }
		
		//[Place|EString]
		public CrossReference getPlacePlaceCrossReference_9_0() { return cPlacePlaceCrossReference_9_0; }
		
		//EString
		public RuleCall getPlacePlaceEStringParserRuleCall_9_0_1() { return cPlacePlaceEStringParserRuleCall_9_0_1; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_10() { return cRightCurlyBracketKeyword_10; }
	}
	public class ArcTPElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.ArcTP");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cArcTPKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cPoidsKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cPoidsAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cPoidsEIntParserRuleCall_3_0 = (RuleCall)cPoidsAssignment_3.eContents().get(0);
		private final Keyword cTransitionKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cTransitionAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final CrossReference cTransitionTransitionCrossReference_5_0 = (CrossReference)cTransitionAssignment_5.eContents().get(0);
		private final RuleCall cTransitionTransitionEStringParserRuleCall_5_0_1 = (RuleCall)cTransitionTransitionCrossReference_5_0.eContents().get(1);
		private final Keyword cPlaceKeyword_6 = (Keyword)cGroup.eContents().get(6);
		private final Assignment cPlaceAssignment_7 = (Assignment)cGroup.eContents().get(7);
		private final CrossReference cPlacePlaceCrossReference_7_0 = (CrossReference)cPlaceAssignment_7.eContents().get(0);
		private final RuleCall cPlacePlaceEStringParserRuleCall_7_0_1 = (RuleCall)cPlacePlaceCrossReference_7_0.eContents().get(1);
		private final Keyword cRightCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		
		//ArcTP:
		//	'ArcTP'
		//	'{'
		//	'poids' poids=EInt
		//	'transition' transition=[Transition|EString]
		//	'place' place=[Place|EString]
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'ArcTP' '{' 'poids' poids=EInt 'transition' transition=[Transition|EString] 'place' place=[Place|EString] '}'
		public Group getGroup() { return cGroup; }
		
		//'ArcTP'
		public Keyword getArcTPKeyword_0() { return cArcTPKeyword_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1() { return cLeftCurlyBracketKeyword_1; }
		
		//'poids'
		public Keyword getPoidsKeyword_2() { return cPoidsKeyword_2; }
		
		//poids=EInt
		public Assignment getPoidsAssignment_3() { return cPoidsAssignment_3; }
		
		//EInt
		public RuleCall getPoidsEIntParserRuleCall_3_0() { return cPoidsEIntParserRuleCall_3_0; }
		
		//'transition'
		public Keyword getTransitionKeyword_4() { return cTransitionKeyword_4; }
		
		//transition=[Transition|EString]
		public Assignment getTransitionAssignment_5() { return cTransitionAssignment_5; }
		
		//[Transition|EString]
		public CrossReference getTransitionTransitionCrossReference_5_0() { return cTransitionTransitionCrossReference_5_0; }
		
		//EString
		public RuleCall getTransitionTransitionEStringParserRuleCall_5_0_1() { return cTransitionTransitionEStringParserRuleCall_5_0_1; }
		
		//'place'
		public Keyword getPlaceKeyword_6() { return cPlaceKeyword_6; }
		
		//place=[Place|EString]
		public Assignment getPlaceAssignment_7() { return cPlaceAssignment_7; }
		
		//[Place|EString]
		public CrossReference getPlacePlaceCrossReference_7_0() { return cPlacePlaceCrossReference_7_0; }
		
		//EString
		public RuleCall getPlacePlaceEStringParserRuleCall_7_0_1() { return cPlacePlaceEStringParserRuleCall_7_0_1; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_8() { return cRightCurlyBracketKeyword_8; }
	}
	public class TransitionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.Transition");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cTransitionKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cNomKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cNomAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cNomEStringParserRuleCall_3_0 = (RuleCall)cNomAssignment_3.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cArctpKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_4_1 = (Keyword)cGroup_4.eContents().get(1);
		private final Assignment cArctpAssignment_4_2 = (Assignment)cGroup_4.eContents().get(2);
		private final CrossReference cArctpArcTPCrossReference_4_2_0 = (CrossReference)cArctpAssignment_4_2.eContents().get(0);
		private final RuleCall cArctpArcTPEStringParserRuleCall_4_2_0_1 = (RuleCall)cArctpArcTPCrossReference_4_2_0.eContents().get(1);
		private final Group cGroup_4_3 = (Group)cGroup_4.eContents().get(3);
		private final Keyword cCommaKeyword_4_3_0 = (Keyword)cGroup_4_3.eContents().get(0);
		private final Assignment cArctpAssignment_4_3_1 = (Assignment)cGroup_4_3.eContents().get(1);
		private final CrossReference cArctpArcTPCrossReference_4_3_1_0 = (CrossReference)cArctpAssignment_4_3_1.eContents().get(0);
		private final RuleCall cArctpArcTPEStringParserRuleCall_4_3_1_0_1 = (RuleCall)cArctpArcTPCrossReference_4_3_1_0.eContents().get(1);
		private final Keyword cRightParenthesisKeyword_4_4 = (Keyword)cGroup_4.eContents().get(4);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cArcptKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_5_1 = (Keyword)cGroup_5.eContents().get(1);
		private final Assignment cArcptAssignment_5_2 = (Assignment)cGroup_5.eContents().get(2);
		private final CrossReference cArcptArcPTCrossReference_5_2_0 = (CrossReference)cArcptAssignment_5_2.eContents().get(0);
		private final RuleCall cArcptArcPTEStringParserRuleCall_5_2_0_1 = (RuleCall)cArcptArcPTCrossReference_5_2_0.eContents().get(1);
		private final Group cGroup_5_3 = (Group)cGroup_5.eContents().get(3);
		private final Keyword cCommaKeyword_5_3_0 = (Keyword)cGroup_5_3.eContents().get(0);
		private final Assignment cArcptAssignment_5_3_1 = (Assignment)cGroup_5_3.eContents().get(1);
		private final CrossReference cArcptArcPTCrossReference_5_3_1_0 = (CrossReference)cArcptAssignment_5_3_1.eContents().get(0);
		private final RuleCall cArcptArcPTEStringParserRuleCall_5_3_1_0_1 = (RuleCall)cArcptArcPTCrossReference_5_3_1_0.eContents().get(1);
		private final Keyword cRightParenthesisKeyword_5_4 = (Keyword)cGroup_5.eContents().get(4);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		
		//Transition:
		//	'Transition'
		//	'{'
		//	'nom' nom=EString ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')? ('arcpt' '('
		//	arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'Transition' '{' 'nom' nom=EString ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')? ('arcpt' '('
		//arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')? '}'
		public Group getGroup() { return cGroup; }
		
		//'Transition'
		public Keyword getTransitionKeyword_0() { return cTransitionKeyword_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1() { return cLeftCurlyBracketKeyword_1; }
		
		//'nom'
		public Keyword getNomKeyword_2() { return cNomKeyword_2; }
		
		//nom=EString
		public Assignment getNomAssignment_3() { return cNomAssignment_3; }
		
		//EString
		public RuleCall getNomEStringParserRuleCall_3_0() { return cNomEStringParserRuleCall_3_0; }
		
		//('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')?
		public Group getGroup_4() { return cGroup_4; }
		
		//'arctp'
		public Keyword getArctpKeyword_4_0() { return cArctpKeyword_4_0; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_4_1() { return cLeftParenthesisKeyword_4_1; }
		
		//arctp+=[ArcTP|EString]
		public Assignment getArctpAssignment_4_2() { return cArctpAssignment_4_2; }
		
		//[ArcTP|EString]
		public CrossReference getArctpArcTPCrossReference_4_2_0() { return cArctpArcTPCrossReference_4_2_0; }
		
		//EString
		public RuleCall getArctpArcTPEStringParserRuleCall_4_2_0_1() { return cArctpArcTPEStringParserRuleCall_4_2_0_1; }
		
		//("," arctp+=[ArcTP|EString])*
		public Group getGroup_4_3() { return cGroup_4_3; }
		
		//","
		public Keyword getCommaKeyword_4_3_0() { return cCommaKeyword_4_3_0; }
		
		//arctp+=[ArcTP|EString]
		public Assignment getArctpAssignment_4_3_1() { return cArctpAssignment_4_3_1; }
		
		//[ArcTP|EString]
		public CrossReference getArctpArcTPCrossReference_4_3_1_0() { return cArctpArcTPCrossReference_4_3_1_0; }
		
		//EString
		public RuleCall getArctpArcTPEStringParserRuleCall_4_3_1_0_1() { return cArctpArcTPEStringParserRuleCall_4_3_1_0_1; }
		
		//')'
		public Keyword getRightParenthesisKeyword_4_4() { return cRightParenthesisKeyword_4_4; }
		
		//('arcpt' '(' arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
		public Group getGroup_5() { return cGroup_5; }
		
		//'arcpt'
		public Keyword getArcptKeyword_5_0() { return cArcptKeyword_5_0; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_5_1() { return cLeftParenthesisKeyword_5_1; }
		
		//arcpt+=[ArcPT|EString]
		public Assignment getArcptAssignment_5_2() { return cArcptAssignment_5_2; }
		
		//[ArcPT|EString]
		public CrossReference getArcptArcPTCrossReference_5_2_0() { return cArcptArcPTCrossReference_5_2_0; }
		
		//EString
		public RuleCall getArcptArcPTEStringParserRuleCall_5_2_0_1() { return cArcptArcPTEStringParserRuleCall_5_2_0_1; }
		
		//("," arcpt+=[ArcPT|EString])*
		public Group getGroup_5_3() { return cGroup_5_3; }
		
		//","
		public Keyword getCommaKeyword_5_3_0() { return cCommaKeyword_5_3_0; }
		
		//arcpt+=[ArcPT|EString]
		public Assignment getArcptAssignment_5_3_1() { return cArcptAssignment_5_3_1; }
		
		//[ArcPT|EString]
		public CrossReference getArcptArcPTCrossReference_5_3_1_0() { return cArcptArcPTCrossReference_5_3_1_0; }
		
		//EString
		public RuleCall getArcptArcPTEStringParserRuleCall_5_3_1_0_1() { return cArcptArcPTEStringParserRuleCall_5_3_1_0_1; }
		
		//')'
		public Keyword getRightParenthesisKeyword_5_4() { return cRightParenthesisKeyword_5_4; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
	}
	public class PlaceElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.Place");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cPlaceKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cNomKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cNomAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final RuleCall cNomEStringParserRuleCall_3_0 = (RuleCall)cNomAssignment_3.eContents().get(0);
		private final Keyword cNbJetonsKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cNbJetonsAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cNbJetonsEIntParserRuleCall_5_0 = (RuleCall)cNbJetonsAssignment_5.eContents().get(0);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cArctpKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_6_1 = (Keyword)cGroup_6.eContents().get(1);
		private final Assignment cArctpAssignment_6_2 = (Assignment)cGroup_6.eContents().get(2);
		private final CrossReference cArctpArcTPCrossReference_6_2_0 = (CrossReference)cArctpAssignment_6_2.eContents().get(0);
		private final RuleCall cArctpArcTPEStringParserRuleCall_6_2_0_1 = (RuleCall)cArctpArcTPCrossReference_6_2_0.eContents().get(1);
		private final Group cGroup_6_3 = (Group)cGroup_6.eContents().get(3);
		private final Keyword cCommaKeyword_6_3_0 = (Keyword)cGroup_6_3.eContents().get(0);
		private final Assignment cArctpAssignment_6_3_1 = (Assignment)cGroup_6_3.eContents().get(1);
		private final CrossReference cArctpArcTPCrossReference_6_3_1_0 = (CrossReference)cArctpAssignment_6_3_1.eContents().get(0);
		private final RuleCall cArctpArcTPEStringParserRuleCall_6_3_1_0_1 = (RuleCall)cArctpArcTPCrossReference_6_3_1_0.eContents().get(1);
		private final Keyword cRightParenthesisKeyword_6_4 = (Keyword)cGroup_6.eContents().get(4);
		private final Group cGroup_7 = (Group)cGroup.eContents().get(7);
		private final Keyword cArcptKeyword_7_0 = (Keyword)cGroup_7.eContents().get(0);
		private final Keyword cLeftParenthesisKeyword_7_1 = (Keyword)cGroup_7.eContents().get(1);
		private final Assignment cArcptAssignment_7_2 = (Assignment)cGroup_7.eContents().get(2);
		private final CrossReference cArcptArcPTCrossReference_7_2_0 = (CrossReference)cArcptAssignment_7_2.eContents().get(0);
		private final RuleCall cArcptArcPTEStringParserRuleCall_7_2_0_1 = (RuleCall)cArcptArcPTCrossReference_7_2_0.eContents().get(1);
		private final Group cGroup_7_3 = (Group)cGroup_7.eContents().get(3);
		private final Keyword cCommaKeyword_7_3_0 = (Keyword)cGroup_7_3.eContents().get(0);
		private final Assignment cArcptAssignment_7_3_1 = (Assignment)cGroup_7_3.eContents().get(1);
		private final CrossReference cArcptArcPTCrossReference_7_3_1_0 = (CrossReference)cArcptAssignment_7_3_1.eContents().get(0);
		private final RuleCall cArcptArcPTEStringParserRuleCall_7_3_1_0_1 = (RuleCall)cArcptArcPTCrossReference_7_3_1_0.eContents().get(1);
		private final Keyword cRightParenthesisKeyword_7_4 = (Keyword)cGroup_7.eContents().get(4);
		private final Keyword cRightCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		
		//Place:
		//	'Place'
		//	'{'
		//	'nom' nom=EString
		//	'nbJetons' nbJetons=EInt ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')? ('arcpt' '('
		//	arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'Place' '{' 'nom' nom=EString 'nbJetons' nbJetons=EInt ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])*
		//')')? ('arcpt' '(' arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')? '}'
		public Group getGroup() { return cGroup; }
		
		//'Place'
		public Keyword getPlaceKeyword_0() { return cPlaceKeyword_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1() { return cLeftCurlyBracketKeyword_1; }
		
		//'nom'
		public Keyword getNomKeyword_2() { return cNomKeyword_2; }
		
		//nom=EString
		public Assignment getNomAssignment_3() { return cNomAssignment_3; }
		
		//EString
		public RuleCall getNomEStringParserRuleCall_3_0() { return cNomEStringParserRuleCall_3_0; }
		
		//'nbJetons'
		public Keyword getNbJetonsKeyword_4() { return cNbJetonsKeyword_4; }
		
		//nbJetons=EInt
		public Assignment getNbJetonsAssignment_5() { return cNbJetonsAssignment_5; }
		
		//EInt
		public RuleCall getNbJetonsEIntParserRuleCall_5_0() { return cNbJetonsEIntParserRuleCall_5_0; }
		
		//('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')?
		public Group getGroup_6() { return cGroup_6; }
		
		//'arctp'
		public Keyword getArctpKeyword_6_0() { return cArctpKeyword_6_0; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_6_1() { return cLeftParenthesisKeyword_6_1; }
		
		//arctp+=[ArcTP|EString]
		public Assignment getArctpAssignment_6_2() { return cArctpAssignment_6_2; }
		
		//[ArcTP|EString]
		public CrossReference getArctpArcTPCrossReference_6_2_0() { return cArctpArcTPCrossReference_6_2_0; }
		
		//EString
		public RuleCall getArctpArcTPEStringParserRuleCall_6_2_0_1() { return cArctpArcTPEStringParserRuleCall_6_2_0_1; }
		
		//("," arctp+=[ArcTP|EString])*
		public Group getGroup_6_3() { return cGroup_6_3; }
		
		//","
		public Keyword getCommaKeyword_6_3_0() { return cCommaKeyword_6_3_0; }
		
		//arctp+=[ArcTP|EString]
		public Assignment getArctpAssignment_6_3_1() { return cArctpAssignment_6_3_1; }
		
		//[ArcTP|EString]
		public CrossReference getArctpArcTPCrossReference_6_3_1_0() { return cArctpArcTPCrossReference_6_3_1_0; }
		
		//EString
		public RuleCall getArctpArcTPEStringParserRuleCall_6_3_1_0_1() { return cArctpArcTPEStringParserRuleCall_6_3_1_0_1; }
		
		//')'
		public Keyword getRightParenthesisKeyword_6_4() { return cRightParenthesisKeyword_6_4; }
		
		//('arcpt' '(' arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
		public Group getGroup_7() { return cGroup_7; }
		
		//'arcpt'
		public Keyword getArcptKeyword_7_0() { return cArcptKeyword_7_0; }
		
		//'('
		public Keyword getLeftParenthesisKeyword_7_1() { return cLeftParenthesisKeyword_7_1; }
		
		//arcpt+=[ArcPT|EString]
		public Assignment getArcptAssignment_7_2() { return cArcptAssignment_7_2; }
		
		//[ArcPT|EString]
		public CrossReference getArcptArcPTCrossReference_7_2_0() { return cArcptArcPTCrossReference_7_2_0; }
		
		//EString
		public RuleCall getArcptArcPTEStringParserRuleCall_7_2_0_1() { return cArcptArcPTEStringParserRuleCall_7_2_0_1; }
		
		//("," arcpt+=[ArcPT|EString])*
		public Group getGroup_7_3() { return cGroup_7_3; }
		
		//","
		public Keyword getCommaKeyword_7_3_0() { return cCommaKeyword_7_3_0; }
		
		//arcpt+=[ArcPT|EString]
		public Assignment getArcptAssignment_7_3_1() { return cArcptAssignment_7_3_1; }
		
		//[ArcPT|EString]
		public CrossReference getArcptArcPTCrossReference_7_3_1_0() { return cArcptArcPTCrossReference_7_3_1_0; }
		
		//EString
		public RuleCall getArcptArcPTEStringParserRuleCall_7_3_1_0_1() { return cArcptArcPTEStringParserRuleCall_7_3_1_0_1; }
		
		//')'
		public Keyword getRightParenthesisKeyword_7_4() { return cRightParenthesisKeyword_7_4; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_8() { return cRightCurlyBracketKeyword_8; }
	}
	
	public class ArcKindElements extends AbstractEnumRuleElementFinder {
		private final EnumRule rule = (EnumRule) GrammarUtil.findRuleForName(getGrammar(), "fr.n7.petrinet.txt.NET.ArcKind");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final EnumLiteralDeclaration cREAD_ARCEnumLiteralDeclaration_0 = (EnumLiteralDeclaration)cAlternatives.eContents().get(0);
		private final Keyword cREAD_ARCREAD_ARCKeyword_0_0 = (Keyword)cREAD_ARCEnumLiteralDeclaration_0.eContents().get(0);
		private final EnumLiteralDeclaration cREGULAREnumLiteralDeclaration_1 = (EnumLiteralDeclaration)cAlternatives.eContents().get(1);
		private final Keyword cREGULARREGULARKeyword_1_0 = (Keyword)cREGULAREnumLiteralDeclaration_1.eContents().get(0);
		
		//enum ArcKind:
		//	READ_ARC | REGULAR;
		public EnumRule getRule() { return rule; }
		
		//READ_ARC | REGULAR
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//READ_ARC
		public EnumLiteralDeclaration getREAD_ARCEnumLiteralDeclaration_0() { return cREAD_ARCEnumLiteralDeclaration_0; }
		
		//'READ_ARC'
		public Keyword getREAD_ARCREAD_ARCKeyword_0_0() { return cREAD_ARCREAD_ARCKeyword_0_0; }
		
		//REGULAR
		public EnumLiteralDeclaration getREGULAREnumLiteralDeclaration_1() { return cREGULAREnumLiteralDeclaration_1; }
		
		//'REGULAR'
		public Keyword getREGULARREGULARKeyword_1_0() { return cREGULARREGULARKeyword_1_0; }
	}
	
	private final ReseauElements pReseau;
	private final ArcElements pArc;
	private final ElementPetriElements pElementPetri;
	private final EStringElements pEString;
	private final EIntElements pEInt;
	private final ArcPTElements pArcPT;
	private final ArcTPElements pArcTP;
	private final TransitionElements pTransition;
	private final PlaceElements pPlace;
	private final ArcKindElements eArcKind;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public NETGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pReseau = new ReseauElements();
		this.pArc = new ArcElements();
		this.pElementPetri = new ElementPetriElements();
		this.pEString = new EStringElements();
		this.pEInt = new EIntElements();
		this.pArcPT = new ArcPTElements();
		this.pArcTP = new ArcTPElements();
		this.pTransition = new TransitionElements();
		this.pPlace = new PlaceElements();
		this.eArcKind = new ArcKindElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("fr.n7.petrinet.txt.NET".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Reseau:
	//	'Reseau'
	//	'{'
	//	'nom' nom=EString ('arc' '{' arc+=Arc ("," arc+=Arc)* '}')?
	//	'elementpetri' '{' elementpetri+=ElementPetri ("," elementpetri+=ElementPetri)* '}'
	//	'}';
	public ReseauElements getReseauAccess() {
		return pReseau;
	}
	
	public ParserRule getReseauRule() {
		return getReseauAccess().getRule();
	}
	
	//Arc:
	//	ArcPT | ArcTP;
	public ArcElements getArcAccess() {
		return pArc;
	}
	
	public ParserRule getArcRule() {
		return getArcAccess().getRule();
	}
	
	//ElementPetri:
	//	Transition | Place;
	public ElementPetriElements getElementPetriAccess() {
		return pElementPetri;
	}
	
	public ParserRule getElementPetriRule() {
		return getElementPetriAccess().getRule();
	}
	
	//EString:
	//	STRING | ID;
	public EStringElements getEStringAccess() {
		return pEString;
	}
	
	public ParserRule getEStringRule() {
		return getEStringAccess().getRule();
	}
	
	//EInt ecore::EInt:
	//	'-'? INT;
	public EIntElements getEIntAccess() {
		return pEInt;
	}
	
	public ParserRule getEIntRule() {
		return getEIntAccess().getRule();
	}
	
	//ArcPT:
	//	'ArcPT'
	//	'{'
	//	'poids' poids=EInt
	//	'type' type=ArcKind
	//	'transition' transition=[Transition|EString]
	//	'place' place=[Place|EString]
	//	'}';
	public ArcPTElements getArcPTAccess() {
		return pArcPT;
	}
	
	public ParserRule getArcPTRule() {
		return getArcPTAccess().getRule();
	}
	
	//ArcTP:
	//	'ArcTP'
	//	'{'
	//	'poids' poids=EInt
	//	'transition' transition=[Transition|EString]
	//	'place' place=[Place|EString]
	//	'}';
	public ArcTPElements getArcTPAccess() {
		return pArcTP;
	}
	
	public ParserRule getArcTPRule() {
		return getArcTPAccess().getRule();
	}
	
	//Transition:
	//	'Transition'
	//	'{'
	//	'nom' nom=EString ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')? ('arcpt' '('
	//	arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
	//	'}';
	public TransitionElements getTransitionAccess() {
		return pTransition;
	}
	
	public ParserRule getTransitionRule() {
		return getTransitionAccess().getRule();
	}
	
	//Place:
	//	'Place'
	//	'{'
	//	'nom' nom=EString
	//	'nbJetons' nbJetons=EInt ('arctp' '(' arctp+=[ArcTP|EString] ("," arctp+=[ArcTP|EString])* ')')? ('arcpt' '('
	//	arcpt+=[ArcPT|EString] ("," arcpt+=[ArcPT|EString])* ')')?
	//	'}';
	public PlaceElements getPlaceAccess() {
		return pPlace;
	}
	
	public ParserRule getPlaceRule() {
		return getPlaceAccess().getRule();
	}
	
	//enum ArcKind:
	//	READ_ARC | REGULAR;
	public ArcKindElements getArcKindAccess() {
		return eArcKind;
	}
	
	public EnumRule getArcKindRule() {
		return getArcKindAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
